% trackingfunksjon.m
clear all;
close all;
clc;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% New try - Net PAE at flat X dB gain
% For flat gain tracking, predefine desired gain and lower vd:
gain = 12;
lower_vd=23;
%Roughly lower bounds for successful square:
%12db -> 23V
%10db -> 16.5V
%9db  -> 14V


close all;
const_pae = 0;
const_pow = 0;
pow_12db = 0;
gain_12db = 0;
% figure(9)
% hold on;
% grid on;
% ColorSet = varycolor(13);
% set(gca, 'ColorOrder', ColorSet)
for i=1:length(vd_corr)
    % if want to plot everything vs P_o in dbm, replace corrected_p_w with
    % corrected_pout_vd inside forloop. Might also have to curvefit for
    % 1:end in dBm, vs. 6:end in W.
    
    % Pae-curves max gain
%     figure(9)
%     plot(corrected_pout_vd(i,:),corrected_pae_vd(i,:), 'linesmooth','on')
%     [dummy pow_idx] = min((corrected_pout_vd(i,:)-fit_points_9db(i)).^2);
    [dummy idx] = min((corrected_gain_vd(i,:)-gain).^2); %finding index on each gain curve closest to X(12) db gain
    % deciding number of dB gain done by changing the row by predefining
    % the gain variable
    % also necessary to change poly_vd in line by predefingin lower_vd
%     const_pae(i) =corrected_pae_vd(i, pow_idx);
%     const_pow(i) = corrected_pout_vd(i, pow_idx);
    
    %gaincurves 12db gain
    figure(8)
    hold on;
    plot(corrected_pout_vd(i,:), corrected_gain_vd(i,:),'Color',[0.75,0.75,0.75], 'linesmooth', 'on')
    gain_12db(i) = corrected_gain_vd(i,idx);
    pow_12db(i) = corrected_pout_vd(i, idx);
    pae_12db(i) = corrected_pae_vd(i,idx);
    
    %pout curves 12db Gain
    figure(7)
    hold on;
%     if i>=7
        plot(corrected_pout_vd(i,:)-corrected_gain_vd(i,:), corrected_pout_vd(i,:), 'Color', [0.75, 0.75, 0.75], 'linesmooth','on');
%     end
    
    
    figure(15)
    hold on;
%     if i>=8
        plot(corrected_pout_vd(i,:), corrected_pae_vd(i,:),'Color',[0.75,0.75,0.75], 'linesmooth', 'on')
%     end
end
% figure(9)
% legend('V_D = 4V', 'V_D = 6V', 'V_D = 8V', 'V_D = 10V', 'V_D = 12V', 'V_D = 14V', 'V_D = 16V', 'V_D = 18V', 'V_D = 20V', 'V_D = 22V', 'V_D = 24V', 'V_D = 26V', 'V_D = 28V','Location','SouthEast')
% ylim([0 75])
% plot(const_pow, const_pae, 'k*')
% fitobject = fit(const_pow(4:end)',const_pae(4:end)','cubicinterp');
% plot(fitobject, 'r')

% title('Net PAE for flat gain tracking 9dB old')
% xlabel('P_o [dBm]');
% ylabel('PAE [%]');vg




% %% Lager trackingfunksjon, Vd(Po[W]) [V] 9db
% figure(10)
% hold all;
% title('V_d(P_o) for 9db constant gain');
% xlabel('P_o [W]');
% ylabel('V_d [V]');
% plot(fit_w, vd_corr, 'o', 'linesmooth','on')
% Creating average for plotting
% avg_vd=polyfit(fit_w(6:end),vd_corr(6:end),1);
% % plot(fit_w(6:end), avg_vd(1)*fit_w(6:end)+avg_vd(2),'r--', 'linesmooth','on')
% 
% if(const_pow(1,end) >40)
%     % need to plot track func vs po in watts, convert if const pow is in
%     % dbm.
%     const_pow = 10.^((const_pow-30)/10);
% end
% % Creating values for curvefitting
% [dummy vd_idx] = min((const_pow(1,:)- 8).^2);
% % vd_at_bo = vd_corr(vd_idx);
% vd_for_poly = [16 vd_corr(vd_idx) 31];
% po_for_poly = [0 const_pow(1,vd_idx) const_pow(1,end)];
% % plot(po_for_poly, vd_for_poly, 'r*')
% 
% poly_coeffs = polyfit(po_for_poly, vd_for_poly, 2);
% poly = poly_coeffs(1)*corrected_p_w(13,:).^2 + poly_coeffs(2)*corrected_p_w(13,:) + poly_coeffs(3);
% poly(1,poly >= 28) = 28;
% plot(corrected_p_w(13,:), poly, 'r', 'linesmooth','on')





% %% Track for flat gain, 12 dB
% Track for 12db flat gain, kan endres til x dB gain flatt.
figure(8)
title('G_T when tracking for constant 12dB gain');
xlabel('P_{out}[dBm]');
ylabel('G_T [dB]');
grid on;
plot(pow_12db, gain_12db, 'r--o', 'linesmooth', 'on')
[dummy idx_12db_last] = min((corrected_pout_vd(13,:)-pow_12db(end)).^2); %identifying startindex for peak track on 28V
plot(corrected_pout_vd(13,idx_12db_last:end), corrected_gain_vd(13,idx_12db_last:end), 'r--o', 'linesmooth','on');

% Pout for 12db
figure(7)
title('P_{out} when tracking for constant 12dB gain');
grid on;
xlabel('P_{in} [dBm]');
ylabel('P_{out} [dBm]');
plot(pow_12db(7:end)-gain_12db(7:end),pow_12db(7:end), 'r--o', 'linesmooth','on')
plot(corrected_pout_vd(13,idx_12db_last:end)-corrected_gain_vd(13,idx_12db_last:end), corrected_pout_vd(13,idx_12db_last:end), 'r--o', 'linesmooth','on');

% Pae for 12db
figure(15)
title('PAE when tracking for constant 12dB gain');
grid on;
xlabel('P_{in} [dBm]');
ylabel('PAE [%]');
plot(pow_12db,pae_12db, 'r--o', 'linesmooth','on')
plot(corrected_pout_vd(13,idx_12db_last:end), corrected_pae_vd(13,idx_12db_last:end), 'r--o', 'linesmooth','on');
ylim([0 75])

vo_12db = sqrt(50.*10.^((pow_12db-30)/10));
vi_12db = sqrt(50.*10.^((pow_12db-gain_12db-30)/10));

% vo_12db = 10.^((pow_12db-30)/10);
% vi_12db = 10.^((pow_12db-gain_12db-30)/10);

figure(16)
title('V_D as function of V_{out}');
hold on;
grid on;
xlabel('V_{out} [V]');
ylabel('V_D [V]');
plot(vo_12db,vd_corr ,'r--o', 'linesmooth','on')
h= line([vo_12db(end) 28],[vd_corr(end) 28]);
set(h,'Color', 'r')

figure(17)
title('V_D as function of V_{in}');
hold on;
grid on;
xlabel('V_{in} [V]');
ylabel('V_D [V]');
plot(vi_12db,vd_corr, 'r--o', 'linesmooth','on')
h= line([vi_12db(end) 9.5],[vd_corr(end) 28]);
set(h,'Color', 'r')
% line([vi_12db(9) vi_12db(13)],[vd_corr(9) vd_corr(13)]);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %% Square tracking of flat gain
% Use
% gain_12db
% pow_12db
% pae_12db
% vo_12db
% vi_12db

%find index with respective compression to find correct pout to make
%tracking function
[dummy, compr_idx] = min((corrected_gain_vd(13,:)-12).^2);
% power at this idx equals vi
vi_at_compr = sqrt(50.*10.^((corrected_pout_vd(13,compr_idx)-corrected_gain_vd(13,compr_idx)-30)/10));
%
%
%
%
%
%
%
poly_vin = [0 vi_12db(end)];
poly_vd = [lower_vd 28]; %sets tracking range for square, change by modifying lower_vd
poly_coeffs = polyfit(poly_vin,poly_vd,2)
square_vi = poly_coeffs(1).*vi_12db.^2 + poly_coeffs(3);
figure(17)
plot(vi_12db, square_vi, 'c','linesmooth','on')

% finding gain curve with square track
square_pin = (square_vi).^2/50;
square_pin = 10*log10(square_pin./1e-3);
vd_rounded = round((square_vi)/2)*2;
%  Need to find indexes on pout
for i=1:length(square_vi)
    [dummy volt_idx] = min((vd_corr-vd_rounded(i)).^2)
    [dummy pow_idx] = min((corrected_pout_vd(volt_idx,:)-pow_12db(i)).^2)
    gain_sq(i) = corrected_gain_vd(volt_idx,pow_idx);
    pae_sq(i) = corrected_pae_vd(volt_idx,pow_idx);
    pout_sq(i) = corrected_pout_vd(volt_idx,pow_idx);
%     vd_sq(i) = sqrt(50*10.^((pout_sq(i)-30)/10));
end


% plotting square pouts, paes, gain curves
figure(8)
plot(pout_sq, gain_sq, 'c*','linesmooth', 'on');
xlim([20 42])
figure(7)
plot(pout_sq-gain_sq, pout_sq, 'c*','linesmooth', 'on');
xlim([10 34])
ylim([15 42])
figure(15)
plot(pout_sq, pae_sq, 'c*','linesmooth', 'on');
xlim([20 42])
figure(16)
plot(vo_12db,square_vi,'c-*')


% 
% %% Printing flat
% figure(15)
% matlab2tikz('track_10dbflat_pae.tikz', 'height', '\figureheight', 'width', '\figurewidth')
% 
% figure(16)
% matlab2tikz('track_10dbflat_vout.tikz', 'height', '\figureheight', 'width', '\figurewidth')
% 
% figure(8)
% matlab2tikz('track_10dbflat_gain.tikz', 'height', '\figureheight', 'width', '\figurewidth')
% 
% figure(17)
% matlab2tikz('track_10dbflat_vin.tikz', 'height', '\figureheight', 'width', '\figurewidth')
% figure(7)
% matlab2tikz('track_10dbflat_pout.tikz', 'height', '\figureheight', 'width', '\figurewidth')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Tracking for max pae
% Locating Point at respective PAE curve for all values of vd to which
% perform curve fit from.
% max_pae = 0;
% max_pow = 0;
% max_pout =0;
% close all;
% 
% figure(11)
% title('Max PAE track')
% hold on;
% grid on;
% for i=6:length(vd_corr)
%     figure(11)
%     plot(corrected_pout_vd(i,:),corrected_pae_vd(i,:),'Color',[0.75,0.75,0.75], 'linesmooth', 'on')
%     [dummy max_pae_idx] = max(corrected_pae_vd(i,:));
% %   [dummy pow_idx] = min((corrected_pout_vd(i,:)-max(corrected_pae_vd(i,:))).^2);
%     max_pae(i) =corrected_pae_vd(i, max_pae_idx);
%     max_pow(i) = corrected_pout_vd(i, max_pae_idx);
%     max_gain(i) = corrected_gain_vd(i,max_pae_idx);
% 
%     figure(13)
%     hold on;
%     grid on;
%     plot(corrected_pout_vd(i,:), corrected_gain_vd(i,:),'Color',[0.75,0.75,0.75], 'linesmooth', 'on')
% 
%     % Pout curves
%     figure(15)
%     hold on;
%     xlabel('P_{in}');
%     ylabel('P_{out}');
% 
%     max_pout(i) = corrected_pout_vd(i,max_pae_idx);
%     plot(corrected_pout_vd(i,:)-corrected_gain_vd(i,:),corrected_pout_vd(i,:),'Color',[0.75,0.75,0.75], 'linesmooth', 'on');
% 
% end
% 
% plot(max_pow(6:end)-max_gain(6:end), max_pout(6:end), 'r:*')
% 
% figure(11)
% plot(max_pow(6:end), max_pae(6:end), 'r*')
% ylim([0 75])
% 
% figure(13)
% %this equates to the gain
% plot(max_pow(6:end), max_gain(6:end), 'r:*')
% title('Gain when tracking max PAE')
% ylim([0,15])
% xlim([20 42])
% 
% % Tracking function
% figure(12)
% title('V_d as function of V_o');
% xlabel('V_{out}');
% ylabel('V_{drain}');
% hold on;
% grid on;
% 
% max_vin = max_pow - max_gain
% max_vin = sqrt(50.*10.^((max_vin-30)/10));
% max_pow_dbm = max_pow;
% max_vd = sqrt(50.*10.^((max_pow-30)/10)); 
% max_pow= 10.^((max_pow-30)/10);
% plot(max_vd(6:end),vd_corr(6:end),  'r*')
% 
% figure(14)
% grid on;
% hold on;
% % line([0,9.5],[0,28])
% title('V_d as function of V_i');
% xlabel('V_{out}');
% ylabel('V_{in}');
% plot(max_vin(6:end),vd_corr(6:end), 'g--o', 'linesmooth', 'on')
% axis tight;
% figure(12)
% % Creating average linear for plotting
% % avg_vd_pae=polyfit(max_vd(1:end),vd_corr(1:end),1);
% % plot(max_vd(1:end), avg_vd_pae(1)*max_vd(1:end)+avg_vd_pae(2),'b:', 'linesmooth','on')
% line([0,28],[0,28])
% 
% %Creating average square for
% [dummy vd_idx_max] = min((max_vd(1,:)- 15).^2);
% % vd_at_bo = vd_corr(vd_idx);
% vd_for_poly_max = [vd_corr(1,end)/2 vd_corr(vd_idx_max)+2 28];
% po_for_poly_max = [0 max_vd(1,vd_idx_max) max_vd(1,end)];
% 
% % corrected_p_w = sqrt(corrected_p_w.*50);
% % poly_coeffs_max = polyfit(po_for_poly_max, vd_for_poly_max, 2);
% % poly_max = poly_coeffs_max(1)*corrected_p_w(13,:).^2 + poly_coeffs_max(2)*corrected_p_w(13,:) + poly_coeffs_max(3);
% % poly_max(1,poly_max >= 28) = 28;
% % plot(corrected_p_w(13,:), poly_max, 'r', 'linesmooth','on')
% 
% %Lager track_pae
% %vd_corr(6) = 14V
% 
% %initializing new track vectors as pae cuntfion for lowest vd of track
% %range, and their respective power levels
% [dummy idx] = max(corrected_pae_vd(6,:));
% max_pae_tracked = corrected_pae_vd(6,1:idx);
% max_pow_tracked = corrected_pout_vd(6,1:idx);
% % lgt = length(max_pae_tracked)
% 
% % Extending track vectors by adding
% for i=(7:13)
%    max_pae_tracked = [max_pae_tracked max_pae(i)];
%    max_pow_tracked = [max_pow_tracked 10*log10(max_pow(i))+30];
% end
% figure(11)
% plot(max_pow_tracked,max_pae_tracked,'r', 'linesmooth', 'on')
% xlim([20 42])
% 
% 
% % %attempting square track on max pae
% % % finding gain curve with square track
% 
% 
% poly_vin = [0 max_vd(end)];
% poly_vd = [14 28];
% poly_coeffs = polyfit(poly_vin,poly_vd,2);
% square_vo = poly_coeffs(1).*max_vd.^2 + poly_coeffs(3);
% figure(12)
% plot(max_vd, square_vo, 'c','linesmooth','on')
% 
% % finding gain curve with square track
% square_pin = (square_vo).^2/50;
% square_pin_dbm = 10*log10(square_pin./1e-3);
% vd_rounded = round((square_vo)/2)*2;
% %  Need to find indexes on pout
% for i=1:length(square_vo)
%     [dummy volt_idx] = min((vd_corr-square_vo(i)).^2);
%     [dummy pow_idx] = min((corrected_pout_vd(volt_idx,:)-max_pow_dbm(i)).^2);
%     gain_sq(i) = corrected_gain_vd(volt_idx,pow_idx);
%     pae_sq(i) = corrected_pae_vd(volt_idx,pow_idx);
%     pout_sq(i) = corrected_pout_vd(volt_idx,pow_idx);
% end
% % plotting square pouts, paes, gain curves
% figure(13)
% plot(pout_sq, gain_sq, 'c*','linesmooth', 'on');
% figure(15)
% plot(pout_sq-gain_sq, pout_sq, 'c*','linesmooth', 'on');
% xlim([10 34])
% ylim([15 42])
% grid on;
% figure(11)
% plot(pout_sq, pae_sq, 'c*','linesmooth', 'on');
% 
% figure(14)
% max_vin_sq = pout_sq-gain_sq;
% max_vin_sq = sqrt(50.*10.^((max_vin_sq-30)/10));
% plot(max_vin_sq,vd_corr, 'c-*', 'linesmooth', 'on')
% xlim([0 11])
% 
% %% Printing max
% % figure(11)
% % matlab2tikz('track_maxpae_pae.tikz', 'height', '\figureheight', 'width', '\figurewidth')
% % 
% % figure(12)
% % matlab2tikz('track_maxpae_vout.tikz', 'height', '\figureheight', 'width', '\figurewidth')
% % 
% % figure(13)
% % matlab2tikz('track_maxpae_gain.tikz', 'height', '\figureheight', 'width', '\figurewidth')
% % 
% % figure(14)
% % matlab2tikz('track_maxpae_vin.tikz', 'height', '\figureheight', 'width', '\figurewidth')
% % figure(15)
% % matlab2tikz('track_maxpae_pout.tikz', 'height', '\figureheight', 'width', '\figurewidth')